// Compile "NT character-mode executable" with  WATCOM C/C++ 11.0
// or with BC++ 3.1 Small MODEL, Signed Chars

#ifdef _GNU_SOURCE
 #include <stdio.h>
 #define SWITCHCHAR0 '-'
 #define SWITCHCHAR1 '-'
#else
 #define SWITCHCHAR0 '-'
 #define SWITCHCHAR1 '/'
 #include <io.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <process.h>
 #include <string.h>
 #include <conio.h>
 #include <dos.h> // BC++ 3.1 def. __DOS_H - using as DOS_16 flag
#endif

#ifdef __DOS_H
 #include <dir.h>
 #define __DOS16__
 #define bufSize 32768L
#else
 #define bufSize 4L*1024L*1024L
 #ifdef _GNU_SOURCE
  #ifdef WIN32
   #include <winnt.h>
  #else
   #include <sys/types.h>
   #include <sys/stat.h>
   #include <utime.h>
  #endif
 #else
  #include <sys/utime.h>
  #include <wtypes.h>
  #include <winnt.h>
  #include <winbase.h>
 #endif
#endif

#define maxFName 255
char buf1[bufSize];
char fnameInpJPG[maxFName] = "\0";
char fnameOutJPG[maxFName] = "\0";
unsigned short ushtv1, ushtv2;
unsigned int i, j, traceFLG = 0, grabFLG = 0;
unsigned char a, b;
unsigned long ulngv, flen, begFPtr = 0;
FILE *hndlInpJPG = NULL, *hndlOutJPG = NULL;
int optionVerbose  = 0; //int optionQuiet = 0;

unsigned char inHex[256] = {
/*00*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*10*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*20*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*30*/  0 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 ,255,255,255,255,255,255,
/*40*/ 255,10 ,11 ,12 ,13 ,14 ,15 ,255,255,255,255,255,255,255,255,255,
/*50*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*60*/ 255,10 ,11 ,12 ,13 ,14 ,15 ,255,255,255,255,255,255,255,255,255,
/*70*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*80*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*90*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*A0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*B0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*C0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*D0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*E0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
/*F0*/ 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255
};

void logoAndVersion(void) {
    printf("\n"
      "  JPGOPT: VIT(R) JPEG info/preview remover/optimizer\n"
      "  Version 1.3  Copyright (C) Vitaliy I. Vasiliev 14.10.2000\n"
      "  Vitaliy Vasiliev homepage: http://www.chat.ru/~vitaliy_vasiliev/\n"
      "  Vitaliy Vasiliev homepage mirror: http://free.prohosting.com/~vitivas/\n"
    );
}

void usage(void) {
    logoAndVersion();
    printf("\n"
      "  Usage: JPGOPT [switches] InputJPG [OutputJPG]\n"
      "  default OutputJPG-name is '$optim$.jpg'\n"
      "  switches:\n"
      "    -t              - trace field removing\n"
      "    -g              - grab/search mode - search and save all JPGs\n"
      "    -b$XXXXXXXX     - beg pointer in file (default is 0)\n"
      "    -q              - quiet mode output\n"
      "    -?, -h          - this help message\n"
    );
    exit(127);
}

int kbhit_(void) {
#ifdef _GNU_SOURCE
    return 1;
#else
    return kbhit();
#endif
}

int getch_(void) {
#ifdef _GNU_SOURCE
    setbuf(stdin, NULL);
    //setvbuf(stdin, NULL, _IONBF, 0);
    //if((fread(&c, 1, 1, stdin)) != 1) { printf("(fread(&ul, 1, 1, frdHndl)) != 1\n"); }
    return fgetc(stdin);
#else
    return getch();
#endif
}

void pause(void) {
    #define Esc 0x001B
    unsigned int pausekey = 0;
    fprintf(stderr, "press any key to continue, ESC to exit...");
    while(!pausekey) {
        if(kbhit_()) { // check for pressing ESCAPE
            if((pausekey = getch_()) == 0)  pausekey = getch_() * 256;
            if(pausekey == Esc) {
                printf("\n*** Exiting by ESCAPE ***\n");
                exit(255);
            }
        }
    }
    fprintf(stderr, "\r                                         \r");
}

int askYN(unsigned int defaultYN) {
    unsigned int a;
    if(defaultYN) printf(" Y");
    else          printf(" N");
    if(!traceFLG) { printf("\n"); return(defaultYN); }
    for(;;) {
        if((a=getch_())==0) getch_();
        if(a==27) {printf("\n\n*** EXITING BY ESCAPE ***\n\n"); exit(1);}
        if(a=='Y'||a=='y') {printf("\x8Y"); return(1);}
        if(a=='N'||a=='n') {printf("\x8N"); return(0);}
        if(a==0x0D)        {return(defaultYN);}
    }
}

unsigned long getArgVal(char* ptrSrc) {
    char *ptrStart;
    unsigned long val = 0;
    ptrStart = ptrSrc;

    if(*ptrSrc == 0) {
        printf("\nError in arguments: constant value expected.\n");
        exit(-1);
    }
    if((*(unsigned short *)ptrSrc != '0' + 256 * 'x') && (*ptrSrc != '$')) {
        while(*ptrSrc >= '0' && *ptrSrc <= '9') {
            val *= 10;
            val += (unsigned long)(*(ptrSrc++) - '0');
        }
    } else { // if beg "0x" or "$" ==> hexadecimal
        ptrSrc++;
        if(*ptrSrc == 'x') ptrSrc++;
        ptrSrc--;
        while(inHex[*++ptrSrc] < 0x10) {
            val *= 0x10;
            val += (unsigned long)(inHex[*ptrSrc]);
        }
    }
    if(*ptrSrc != 0) {
        printf("\ninvalid constant value: '%s'\n",ptrStart);
        exit(-1);
    }
    return(val);
}

unsigned long getArg(char *outStr, char *argv[], char *argN, char *dflt) {
    // if(outStr == NULL) get argument/switch value
    // 'argN' is argument number ("1", "2",..."99") or switch name ("-q", "-b")
    // 'dflt' is default returning value - use NULL if value must be defined
    //  in command line
    // will be returned pointer:
    //  for arg              - pointer to arg or 'dflt' if arg not def. in
    //                         command line and dflt!=NULL
    //  for arg=value        - pointer to "value" or pointer to 'dflt'
    //  for arg:value        - pointer to "value" or pointer to 'dflt'
    //  for swith as -q[Y|N] - pointer to cahr after "-q" or 'dflt' if switch
    //                         not def. in command line
    //  for swith as -b1234  - pointer to "1234" or pointer to 'dflt'
    //  for swith as -b=1234 - pointer to "1234" or pointer to 'dflt'
    //  for swith as -b 1234 - pointer to "1234" (next non-switch command line
    //                         arg) or pointer to 'dflt'
    unsigned long retVal = 0;
    char *outPtr = dflt;
    int a = 0;
    int i = 0;
    int an = -1;
    if(argN[0] == '-') { // if switch
        for(an = 0; argN[an + 1] != 0; an++) ;
        for(a = 1; argv[a] != NULL; a++) { // for every command line arg
            if(argv[a][0] == SWITCHCHAR0 || argv[a][0] == SWITCHCHAR1) {
                for(i = 0; i < an; i++) if(argv[a][i + 1] != argN[i + 1]) break;
                if(i != an) continue;
                break;
            } else { // if argument - may be "switch=value" - checking:
                for(i = 0; i < an; i++) if(argv[a][i] != argN[i + 1]) break;
                if(i != an) continue;
                if(argv[a][i] != ':') continue;
                if(argv[a][i] != '=') continue;
                printf("switch=value: argv[a]=%s\n", argv[a]);
                pause();
                continue;
            }
        }
        if(argv[a] != NULL) {
            i++;
            if(argv[a][i] == ':') i++;
            if(argv[a][i] == '=') i++;
            outPtr = &argv[a][i];
            if(outStr == NULL && argv[a][0] == '-' && (argv[a][1] == 'q' || argv[a][1] == 'Q') && argv[a][2] == 0) return 1;
            if(optionVerbose) printf("accept CmdLn switch %s", argN);
            if(outStr == NULL && dflt[1] == 0 && dflt[0] == '+') { if(optionVerbose) printf("\n"); return 1; }
            if(outStr == NULL && dflt[1] == 0 && dflt[0] == '-') { if(optionVerbose) printf("\n"); return 0; }
        } else {
            if(outStr == NULL && dflt[1] == 0 && dflt[0] == '+') return 0;
            if(outStr == NULL && dflt[1] == 0 && dflt[0] == '-') return 1;
            if(optionVerbose) printf("absent CmdLn switch %s", argN);
            if(outPtr == NULL) {
                printf("\n Error in command line arguments: must be defined argunment %s.\n", argN);
                usage(); // and exit();
            } else {
                if(optionVerbose) printf(": using default");
            }
        }
        if(outStr == NULL) {
            retVal = getArgVal(outPtr);
            if(optionVerbose) printf(": val %ld (0x%lX) parsed \"%s\"\n", retVal, retVal, outPtr);
            return retVal;
        }
        strcpy(outStr, outPtr);
        if(optionVerbose) printf(": str \"%s\"\n", outStr);
        return 0;
    } else { // find (an)-argument
        an = getArgVal(argN);
        for(a = 1; argv[a] != NULL; a++) { // for every command line arg
            if(argv[a][0] == SWITCHCHAR0) continue; // skip switch
            if(argv[a][0] == SWITCHCHAR1) continue; // skip switch
            if(--an == 0) break;
        }
        if(an == 0) {
            outPtr = argv[a];
            if(optionVerbose) printf("accept CmdLn argument %s", argN);
        } else {
            if(optionVerbose) printf("absent CmdLn argument %s", argN);
            if(outPtr == NULL) {
                printf("\n Error in command line arguments: must be defined argunment %s.\n", argN);
                usage(); // and exit();
            } else {
                if(optionVerbose) printf(": using default");
            }
        }
        if(outStr == NULL) {
            retVal = getArgVal(outPtr);
            if(optionVerbose) printf(": val %ld (0x%lX) parsed \"%s\"\n", retVal, retVal, outPtr);
            return retVal;
        }
        strcpy(outStr, outPtr);
        if(optionVerbose) printf(": str \"%s\"\n", outStr);
        return -1;
    }
}

int frdChk(char* frdBuf, unsigned long frdLen, FILE* frdHndl, char* frdName) {
    memset(frdBuf, 0, frdLen);
    if((fread(&frdBuf[0], frdLen, 1, frdHndl)) != 1) {
        printf("Unexpected EOF or error reading file '%s'\n", frdName);
        return 1;
    }
    return 0;
}

void fwrChk(char* fwrBuf, unsigned long fwrLen, FILE* fwrHndl, char* fwrName) {
    if((fwrite(&fwrBuf[0], fwrLen, 1, fwrHndl)) != 1) {
        printf("Error writing file '%s'\n", fwrName);
        exit(3);
    }
}

int copy_ftime(char* fnameInp, char* fnameOut) {
#ifdef __DOS16__
    FILE *InpHndl = NULL;
    FILE *OutHndl = NULL;
    unsigned int uintv;
    unsigned short  ElemTime, ElemDate;
    // copy date and time of file under DOS16:
    if((InpHndl = fopen(fnameInp, "rb")) == NULL)
        { printf("open %s for setTimeDate failed\n", fnameInp); pause(); }
    if((OutHndl = fopen(fnameOut, "rb")) == NULL)
        { printf("open %s for setTimeDate failed\n", fnameOut); pause(); }
    uintv = fileno(InpHndl);
    if(_dos_getftime(uintv, &(unsigned)ElemDate, &(unsigned)ElemTime))
        { printf("ERROR get date and time for '%s'", fnameInp); pause(); }
    uintv = fileno(OutHndl);
    if(_dos_setftime(uintv, ElemDate, ElemTime))
        { printf("ERROR set date and time for '%s'", fnameOut); pause(); }
    fclose(InpHndl);
    fclose(OutHndl);
    return 0;
#else
 #ifdef WIN32
    FILE *InpHndl = NULL;
    FILE *OutHndl = NULL;
    struct _FILETIME fCreationTime;     // time the file was created
    struct _FILETIME fLastAccessTime;   // time the file was last accessed
    struct _FILETIME fLastWriteTime;    // time the file was last written (lastModify)
    // copy date and time of file under Win32:
    InpHndl = (FILE*)CreateFile(
      fnameInp,                    // pointer to name of the file
      GENERIC_READ,               // access (read-write) mode
      FILE_SHARE_READ,            // share mode
      NULL,                       // pointer to security attributes
      OPEN_EXISTING,              // how to create
      FILE_ATTRIBUTE_HIDDEN,      // file attributes
      NULL                        // handle to file with attributes to copy
    );
    OutHndl = (FILE*)CreateFile(
      fnameOut,                    // pointer to name of the file
      GENERIC_WRITE,              // access (read-write) mode
      FILE_SHARE_READ,            // share mode
      NULL,                       // pointer to security attributes
      OPEN_EXISTING,              // how to create
      FILE_ATTRIBUTE_HIDDEN,      // file attributes
      NULL                        // handle to file with attributes to copy
    );
    //CoDosDateTimeToFileTime(ElemDate, ElemTime, &fCreationTime);
    //LocalFileTimeToFileTime(&fCreationTime, &fCreationTime);
    if(!GetFileTime(InpHndl, &fCreationTime, &fLastAccessTime, &fLastWriteTime))
        { printf("ERROR get date and time for '%s'\n", fnameInp); pause(); }
    fLastAccessTime = fLastWriteTime; // set as Modified
    fCreationTime   = fLastWriteTime; // set as Modified
    if(!SetFileTime(OutHndl, &fCreationTime, &fLastAccessTime, &fLastWriteTime))
        { printf("ERROR set date and time for '%s'\n", fnameOut); pause(); }
    if(!CloseHandle(OutHndl)) { printf("Err CloseHandle of file: %s\n", fnameInp); pause(); }
    if(!CloseHandle(InpHndl)) { printf("Err CloseHandle of file: %s\n", fnameOut); pause(); }
    return 0;
 #else
    // under unix:
    struct stat statBuf;
    struct utimbuf utimbufTimes;
    if(stat(fnameInp, &statBuf) != 0) {
        printf("copy_ftime() under unix: if(fstat(fnameInp, &buf) != 0) { fnameInp='%s'!!!\n", fnameInp);
        return 1;
    }
    // utime - ⠭ ६ 㯠  䨪樨 䠩
    // http://www.citforum.ru/operating_systems/manpages/UTIME.2.shtml
    // read file's attributes, Access time, Modification time:
    // http://www.citforum.ru/operating_systems/manpages/STAT.2.shtml
    utimbufTimes.actime  = statBuf.st_atime; // Access time (६ ᫥ 㯠  䠩)
    utimbufTimes.modtime = statBuf.st_mtime; // Modification time (६ ᫥   䠩)
    if(utime(fnameOut, &utimbufTimes)!=0) {
        printf("setFileDateTime() under unix: can't can't utime() '%s'!!!\n", fnameOut);
        return 2;
    }
    return 0;
 #endif
#endif
}

int main(int argc, char *argv[]) {
    unsigned long curFPtr = 0;

    //optionQuiet |= getArg(NULL, argv, "-q", "+");
    //optionQuiet |= getArg(NULL, argv, "-Q", "+");
    optionVerbose |= getArg(NULL, argv, "-v", "+");
    optionVerbose |= getArg(NULL, argv, "-V", "+");

    if(getArg(NULL, argv, "-?", "+")) usage();
    if(getArg(NULL, argv, "-h", "+")) usage();
    if(getArg(NULL, argv, "-H", "+")) usage();

    getArg(fnameInpJPG, argv, "1", NULL);
    getArg(fnameOutJPG, argv, "2", "$optim$.jpg");
    getArg(buf1, argv, "3", "\t");
    if(buf1[0] != '\t') {
        printf("Error in command line - may be only 2 non-switch arguments - 3rd argument ignored: %s\n", buf1);
    }

    if(begFPtr == 0) begFPtr = getArg(NULL, argv, "-b", "0");
    if(begFPtr == 0) begFPtr = getArg(NULL, argv, "-B", "0");

    // Grab mode:
    grabFLG |= getArg(NULL, argv, "-g", "+");
    grabFLG |= getArg(NULL, argv, "-G", "+");

    // trace mode:
    traceFLG |= getArg(NULL, argv, "-t", "+");
    traceFLG |= getArg(NULL, argv, "-T", "+");


    printf("\n\nInput_JPG_file: '%s'\n", fnameInpJPG);
    if((hndlInpJPG = fopen(&fnameInpJPG[0], "rb")) == NULL) {
        printf("Cannot open for read input file: %s.\n", fnameInpJPG);
        exit(-2);
    }

    fseek(hndlInpJPG, 0L, SEEK_END);
    flen = ftell(hndlInpJPG);
    fseek(hndlInpJPG, begFPtr, SEEK_SET);
    printf("Input_JPG_file_length = %ld byte(s)\n", (unsigned long)flen);

    for(;;) {
        int readErrCode = frdChk((char*)&ushtv1, 2, hndlInpJPG, fnameInpJPG);
        if(readErrCode) exit(200);
        if(ushtv1!=0xD8FF) {
            printf("Invalid_start_JPG_id: must be 0xD8FF\n", fnameOutJPG);
            printf("Search for JPG ?[Y,N,ESC]", fnameOutJPG);
            if(askYN(1)) {
                printf("\n");
                for(;;) {
                    readErrCode = frdChk((char*)&a, 1, hndlInpJPG, fnameInpJPG);
                    if(readErrCode) exit(201);
                    if(a==0xD8 && b==0xFF) {
                        curFPtr = (unsigned long)(ftell(hndlInpJPG)-2);
                        readErrCode = frdChk((char*)&ushtv1, 2, hndlInpJPG, fnameInpJPG);
                        if(readErrCode) exit(202);
                        readErrCode = frdChk((char*)&ushtv2, 2, hndlInpJPG, fnameInpJPG);
                        if(readErrCode) exit(203);
                        readErrCode = frdChk((char*)&ulngv, 4, hndlInpJPG, fnameInpJPG);
                        if(readErrCode) exit(204);
                        fseek(hndlInpJPG, curFPtr + 2, SEEK_SET);
                        if(ushtv1 != 0xe0ff) continue;
                        if(ulngv != 0x4649464A) continue;
                        ushtv1=0xD8FF;
                        break;
                    }
                    b=a;
                }
                printf("Found 0xD8FF at 0x%08lX\n", curFPtr);
            }
            else exit(-2);
        }

        if(grabFLG) sprintf(fnameOutJPG, "%08lX.JPG", curFPtr);
        printf("Output_JPG_file: '%s'\n", fnameOutJPG);
        if((hndlOutJPG=fopen(&fnameOutJPG[0], "wb")) == NULL) {
            printf("Cannot create output file: %s.\n", fnameOutJPG);
            exit(-2);
        }
        fwrChk((char*)&ushtv1, 2, hndlOutJPG, fnameOutJPG);
        
        for(;;) {
            readErrCode = frdChk(((char*)&ushtv1)  , 2, hndlInpJPG, fnameInpJPG);
            if(readErrCode) exit(205);
            if(ushtv1==0xDAFF) break;
            readErrCode = frdChk(((char*)&ushtv2) + 1, 1, hndlInpJPG, fnameInpJPG);
            if(readErrCode) exit(206);
            readErrCode = frdChk(((char*)&ushtv2) + 0, 1, hndlInpJPG, fnameInpJPG);
            if(readErrCode) exit(207);
            printf("Block_Id=0x%04lX, block_Len=0x%04lX in file '%s' at 0x%06lX", (unsigned long)ushtv1, (unsigned long)ushtv2, fnameInpJPG, (unsigned long)(ftell(hndlInpJPG)-4));
        
            if(
            ushtv1==0xE0FF ||
            ushtv1==0xDBFF ||
            ushtv1==0xC0FF ||
            ushtv1==0xDDFF ||
            ushtv1==0xC1FF ||
            ushtv1==0xC2FF ||
            ushtv1==0xC4FF) i=1;
            else i=0;
            if(traceFLG) {/*printf(" [Y,N,ESC]");*/ i=(askYN(i));}
            if(i) { // ᫨  ஢:
                fwrChk(((char*)&ushtv1)    , 2, hndlOutJPG, fnameOutJPG);
                fwrChk(((char*)&ushtv2) + 1, 1, hndlOutJPG, fnameOutJPG);
                fwrChk(((char*)&ushtv2) + 0, 1, hndlOutJPG, fnameOutJPG);
                --ushtv2;
                while(--ushtv2) {
                    readErrCode = frdChk((char*)&a, 1, hndlInpJPG, fnameInpJPG);
                    if(readErrCode) break;
                    fwrChk((char*)&a, 1, hndlOutJPG, fnameOutJPG);
                }
                printf(" +\n");
            }
            else { // ᫨   ஢:
                --ushtv2;
                while(--ushtv2) {
                    readErrCode = frdChk((char*)&a, 1, hndlInpJPG, fnameInpJPG);
                    if(readErrCode) break;
                }
                printf(" -\n");
            }
        }
        printf("Block_imageJPG (block_Id=0xDAFF) at 0x%06lX -- copying...\n", (unsigned long)(ftell(hndlInpJPG)-2));
        fwrChk((char*)&ushtv1, 2, hndlOutJPG, fnameOutJPG);
        b=0;
        for(;;) {
            readErrCode = frdChk((char*)&a, 1, hndlInpJPG, fnameInpJPG);
            if(readErrCode) break;
            fwrChk((char*)&a, 1, hndlOutJPG, fnameOutJPG);
            if(a==0xD9 && b==0xFF) break;
            b=a;
        }
        fclose(hndlOutJPG);
        if((fread((char*)&a, 1, 1, hndlInpJPG)) == 1) {
            printf("Warning: extra byte(s) in input JPG '%s' at 0x%lX\n", fnameInpJPG, ftell(hndlInpJPG)-1L);
            //pause();
        }
        fclose(hndlInpJPG);
        copy_ftime(fnameInpJPG, fnameOutJPG);
        if(!grabFLG) break;
    }
    printf("\nOK.");
    return 0;
}
